-- -------------------------------------------------------------------------- --
-- GroupProgress By Xulos ( EU ALLIANCE YSONDRE )      
-- -------------------------------------------------------------------------- --UIPanelWindows["GroupProgressFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };
GroupProgress = {};
GroupProgress.version = GetAddOnMetadata("GroupProgress", "Version");
GroupProgress.BARRES = {};
-- static
function GroupProgressFrame_Init(self)
	GroupProgressDB = GroupProgressDB or {};
	GroupProgressDB.Params = GroupProgressDB.Params or {};
	GroupProgressDB.Params.PlayerBarHeight = 10;
	GroupProgressDB.Params.PlayerBarWidth = 150;
	GroupProgressDB.Params.Showed = GroupProgressDB.Params.Showed or false;
			
	GroupProgress.AddonPrefix = "GPP_5.4.0";
	RegisterAddonMessagePrefix(GroupProgress.AddonPrefix);
	
	local localizedClass = "";
	localizedClass, GroupProgress.MyClass = UnitClass("player");
	
	GroupProgressDB.PartyLst = {};
	
	GroupProgress.MyName = UnitName("player");
	GroupProgress:AddPlayerForSharing(GroupProgress.MyName);
	
	if ( GroupProgressDB.Params.Showed == true ) then GroupProgressFrame:Show(); end
end
function GroupProgressMinimapButton_OnClick(self)
    if (GroupProgressFrame) then
        if(GroupProgressFrame:IsVisible() ) then
            GroupProgressFrame:Hide();
			GroupProgressDB.Params.Showed = false;
		else
            GroupProgressFrame:Show();
			GroupProgressDB.Params.Showed = true;
		end
    end
	GroupProgress:SharingXP();
end
function GroupProgressButtonTemplate_OnLoad(self)
end
function GroupProgressMinimapButton_OnLoad(self)
	GroupProgressMinimapButton.label:SetText("GPP");
end
function GroupProgressMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("GroupProgress "..GroupProgress.version);
end
function GroupProgressMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function GroupProgressFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("PLAYER_XP_UPDATE");
	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	self:RegisterEvent("CHAT_MSG_ADDON");
	self:RegisterEvent("PARTY_MEMBERS_CHANGED");
end
function GroupProgressFrame_OnEvent(self, event, arg1, arg2, ...)
	if ( event == "VARIABLES_LOADED" ) then
		GroupProgressFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_LEVEL_UP" ) then -- arg1 New player level. Note that UnitLevel("player") will most likely return an incorrect value when called in this event handler or shortly after, so use this value. 
		GroupProgress:XPChanged(arg1);
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_XP_UPDATE" ) then -- arg1 The UnitId affected, eg: "player" 
		GroupProgress:XPChanged();
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "CHAT_MSG_COMBAT_XP_GAIN" ) then -- arg1 chat message 
		GroupProgress:XPChanged();
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "CHAT_MSG_ADDON" ) then -- arg1 prefix arg2 msg arg3 party arg4 sender
		if ( arg1 == GroupProgress.AddonPrefix ) then GroupProgress:SharingReceived(arg2); end
		GroupProgress:UpdateFrame();
	elseif ( event == "PARTY_MEMBERS_CHANGED" ) then
		GroupProgress:XPChanged();
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		GroupProgress:XPChanged();
		GroupProgress:InitFrame();
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			GroupProgress:XPChanged();
			GroupProgress:SharingXP();
			GroupProgress:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("GroupProgress "..GroupProgress.version.." LOADED");
			GroupProgress:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("GroupProgress "..GroupProgress.version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	end
end
-- kernel
function GroupProgress:XPChanged(arg1) -- ok 
	GroupProgress[GroupProgress.MyName] = GroupProgress[GroupProgress.MyName] or {};
	GroupProgress[GroupProgress.MyName].Name = GroupProgress.MyName;
	GroupProgress[GroupProgress.MyName].CurXP = UnitXP("player");
	GroupProgress[GroupProgress.MyName].MaxXP = UnitXPMax("player");
	GroupProgress[GroupProgress.MyName].Class = GroupProgress.MyClass;
	if ( arg1 == nil ) then GroupProgress[GroupProgress.MyName].Lvl = UnitLevel("player");
	else GroupProgress[GroupProgress.MyName].Lvl = arg1; end
	local infos = GroupProgress[GroupProgress.MyName];
	GroupProgress[GroupProgress.MyName].Share = GroupProgress.version.."/"..GroupProgress.MyName.."/"..infos.Lvl.."/"..infos.CurXP.."/"..infos.MaxXP.."/"..infos.Class;
end
function GroupProgress:SharingXP() -- ok
	if ( GroupProgress[GroupProgress.MyName] ) then
		SendAddonMessage(GroupProgress.AddonPrefix, GroupProgress[GroupProgress.MyName].Share, "RAID");
	end
end
function GroupProgress:SharingReceived(msg) -- ok
	if ( msg ) then
		--print(msg);
		local version, v0, v1, v2, v3, v4 = string.match(msg,"(.+)/(%a+)/(%d+)/(%d+)/(%d+)/(%a+)"); -- "5.4.0.6/Xulos/90/100000/100000/DK"
		if ( version and v0 and v1 and v2 and v3 and v4 ) then
			if ( GroupProgress[v0] == nil ) then 
				if ( UnitAffectingCombat("player") == nil ) then
					GroupProgress:XPChanged();
					GroupProgress:SharingXP();
					GroupProgress:InitFrame();
				end
			end
			GroupProgress[v0] = GroupProgress[v0] or {};
			GroupProgress[v0].Name = v0;
			GroupProgress:AddPlayerForSharing(v0);
			GroupProgress[v0].CurXP = v2;
			GroupProgress[v0].MaxXP = v3;
			GroupProgress[v0].Lvl = v1;
			GroupProgress[v0].Class = v4;
			GroupProgress:UpdateFrame();
			if ( version > GroupProgress.version ) then
				if ( GroupProgress.alert == nil ) then
					print("YOUR VERSION V"..GroupProgress.version.." IS OLD ! UPDATE IT FOR V"..version.." !");
					GroupProgress.alert = 1;
				elseif ( GroupProgress.alert <=3 ) then
					print("YOUR VERSION IS OLD ! UPDATE IT !");
					GroupProgress.alert = GroupProgress.alert + 1;
				end
			end
		end
	end
end
function GroupProgress:AddPlayerForSharing(pName)
	GroupProgress.PartyLst = GroupProgress.PartyLst or {};
	if ( not GroupProgress.PartyLst[pName] ) then
		GroupProgress.PartyLst[pName]=1;
		if ( GroupProgress.CountPlayer ) then
			GroupProgress.CountPlayer = GroupProgress.CountPlayer + 1;
		else
			GroupProgress.CountPlayer = 1;
		end
	end	
end
function GroupProgress:CreateBar(frmName) -- ok
    local PlayerBar = CreateFrame("Button", frmName, MoneyBarsGroupProgressFrame, "GroupProgressBarTemplate");
        
	PlayerBar:RegisterForClicks("AnyUp");
	
	PlayerBar.Pointer = _G[frmName.."Pointer"];
	PlayerBar.PlayerNameLabel = _G[frmName.."PlayerNameLabel"];
	PlayerBar.PlayerNameLevel = _G[frmName.."PlayerNameLevel"];
	PlayerBar.PlayerProgress = _G[frmName.."PlayerProgress"];
	
	PlayerBar.StatusBar = _G[frmName.."StatusBar"];
	PlayerBar.StatusBar:SetValue(100);
	PlayerBar.StatusBar:SetMinMaxValues(0, 100);
    
    PlayerBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    PlayerBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	PlayerBar.BtnDown = false;
	
	return PlayerBar;
end
function GroupProgress:InitFrame() -- ok
	if ( #GroupProgress.BARRES ~= GroupProgress.CountPlayer or #GroupProgress.BARRES == 0 ) then
		local idx = 1;
		for k, v in pairs(GroupProgress.PartyLst) do 
			if ( k and v ) then 
				local frmName = "GroupProgressBar"..tostring(idx);
				if ( _G[frmName] == nil ) then -- si la barre a pas encore t cr on la cr / permet de s'assurer qu'on aura tujours un nombre de barres suffisant et en corlation avec la fenetre
					local Bar = GroupProgress:CreateBar(frmName);
					--Bar:Hide(); provoquera des bug en combat vaut mieux la rendre transaprante en modifiant les porprits de ses enfants
					GroupProgress.BARRES[idx] = Bar;
				end
				idx = idx + 1;
			end
		end 
	
		local offset = 5;
		local mFrameContainer = GroupProgressFrame;
		local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
		nrowMax = math.ceil(#GroupProgress.BARRES);
		mFrameContainer:SetWidth(GroupProgressDB.Params.PlayerBarWidth);
		local mFrameWidth = mFrameContainer:GetWidth() - offset;
		itW = mFrameWidth - offset;
		itH = GroupProgressDB.Params.PlayerBarHeight;
		local heightMax = nrowMax * itH + offset*(nrowMax+1);
		mFrameContainer:SetHeight(heightMax);
		local mFrameHeight = mFrameContainer:GetHeight() - offset;
		
		local Row, Col = 0, 0;
		for idx, guiBar in pairs(GroupProgress.BARRES) do
			if ( guiBar ) then
				guiBar:SetParent(mFrameContainer);
				Row = math.floor((idx-1));
				Col = (idx-1)- Row;
				TopLeftX = Col * itW + offset*(Col+1);
				TopLeftY = Row * itH * -1 - offset*(Row+1);
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", TopLeftX, TopLeftY);
				guiBar:SetWidth(itW);
				guiBar:SetHeight(itH);
			end
		end
	end
end
function GroupProgress:ResetBar(GuiBar) -- ok
	if ( GuiBar ) then
		GuiBar.Pointer:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.PlayerNameLabel:SetText("");
		GuiBar.PlayerNameLevel:SetText("");
		GuiBar.PlayerProgress:SetText("");
		GuiBar.StatusBar:SetValue(0);
		GuiBar.StatusBar:SetMinMaxValues(0, 100);
		GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
		GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
		GuiBar.BtnDown = false;
	end
end
function GroupProgress:FormatAmountToPercentValue(val, precision, total)
	if ( val and precision and total ) then
		local percentVal = (val*100)/total;
		return tonumber(string.format("%."..tostring(0).."f", percentVal));
	else
		return -1;
	end
end
function GroupProgress:GetColorCodeFromRGB(red, green, blue) -- de 0  1 en float
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFF"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function GroupProgress:GetColorCodeFromRGBStruct(rgbStruct) -- de 0  1 en float
	local codeWow = GroupProgress:GetColorCodeFromRGB(rgbStruct.r, rgbStruct.g, rgbStruct.b);
	return codeWow; 
end
function GroupProgress:UpdateFrame() -- ok
	local PlayerListToSort = {};
	for playerIndexer, val in pairs(GroupProgress.PartyLst) do
        if ( playerIndexer and val ) then 
			tinsert(PlayerListToSort, playerIndexer);
        end
    end
	sort(PlayerListToSort);
	for i, bar in pairs(GroupProgress.BARRES) do
		if ( bar ) then
			GroupProgress:ResetBar(bar);
		end
	end
	local idx = 1;
    for index, playerIndexer in pairs(PlayerListToSort) do
		if ( playerIndexer ) then
            local GuiBar = GroupProgress.BARRES[idx];
			idx = idx + 1;
            if ( GuiBar ) then
                local frmName = GuiBar:GetName();
				local infos = GroupProgress[playerIndexer];
				if ( infos ) then
					local codeColor = "";
					if ( infos.Class ) then
						local classR, classG, classB =  
							RAID_CLASS_COLORS[infos.Class].r, 
							RAID_CLASS_COLORS[infos.Class].g,
							RAID_CLASS_COLORS[infos.Class].b;
						GuiBar.StatusBar:SetStatusBarColor(classR, classG, classB, 1);
						codeColor = GroupProgress:GetColorCodeFromRGB(classR, classG, classB) or "";
					end
					GuiBar.PlayerNameLabel:SetText(codeColor..infos.Name);
					GuiBar.PlayerNameLevel:SetText(codeColor..tostring(infos.Lvl));
					local vPercent = GroupProgress:FormatAmountToPercentValue(infos.CurXP, 1, infos.MaxXP);
					GuiBar.PlayerProgress:SetText(tostring(vPercent).."%");
					GuiBar.StatusBar:SetValue(vPercent);
				end
            end
		end
    end
end
